/**
 *
 * @date 2015-01-08
 * @note -P IvVǉ
 *
 * @date 2015-01-08
 * @note 傫ȃf[^̂߂ɁA݂ɂB
 *
 * @date 2015-01-08
 * @note p[^ "ClockCycle",	"StartTiming"̌B (CO%f)
 *
 */

#if defined(WIN32) || defined(WIN64)
/* Obsolete code for modern VS Express environment, 2013/8/12 by Nakanishi
 #ifndef _WIN32_WINNT
 #define _WIN32_WINNT	(0x0400)
 #endif
 */ 
 #pragma warning(disable:4786)
#else
 #include <string>
 #include <errno.h>
#endif // WIN32

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "retrieve.h"
#include "Transd_Retrieve.h"

#define RAW_DATA	1
#define ANA_DATA	2

#define	startIndexNoClosing()	IndexNoClosing(1)
#define	endIndexNoClosing()		IndexNoClosing(0)

#define	DISP	(bSilent==0)

/*
@Windows7̏ꍇA傫ȃf[^xfwriteƁA̗ʂɂāAKvƂB
@̂ƂAɗ]TȂꍇAmۂł܂ŁAwait悤łBi[vHj
@ŏIIɊmۂłȂꍇɁAG[ɂ邩ȂAȂ莞Ԃv̂ŁAKȃTCY
@ŕď݂ƂB 

@ICH-ICEv̂߂Ɂ@2015-01-08
*/
#define	SUITABLE_COUNT	(5*1024*1024)
int64_t subdivided_fwrite(const void* w_str, size_t w_size, int64_t large_count, FILE* fp)
{
	int64_t offset=0;
	int64_t remain_count = large_count;
	size_t w_count=0;
	size_t ret_count=0;
	for(;;) {
		w_count = SUITABLE_COUNT;
		if( remain_count < SUITABLE_COUNT ) w_count=remain_count;
		ret_count = fwrite((char*)w_str+offset, w_size, w_count, fp);
		offset += ret_count*w_size;
		remain_count -= ret_count;
		if( 0 == remain_count || 0 == ret_count ) break;
	}
	return(large_count - remain_count);
}

int Usage( const char* av0)
{
	printf(" Retrieve version %s, Library version %s, zlib %s (%s %s)\n\n",
		RETRIEVE_VERSION, retrieveVersion(), retrieveZversion(), __DATE__, __TIME__);
	printf("Usage: %s diag shot subshot chno [filename] [options...]\n",av0);

	printf("\n== Primary arguements ==\n");
	printf("	(1) diag name ( Magnetics, Thomson, ...)\n");
	printf("	(2) shot number\n");
	printf("	(3) subshot number\n");
	printf("	(4) channel number(s) (e.g. 1,3,5-8  1,3,5:8  0=all )\n");
	printf("	         or a signal tag name (e.g. sig-tag1 )\n");
	printf("	(5) [ file or path(.../) name ]\n");
	printf("	    ( files will be \"'filename'-'shot'-'subshot'-'chno'.dat\" )\n");
	printf("	    ( or \"'pathname(.../)'+'diag'-'shot'-'subshot'-'chno'.dat\" )\n");

	printf("\n== Options ==\n");
	printf("	[ --et range | --tt range | --ss range ]      (e.g. 1.0:2.0s  (s,ms,us) 1000:2000)\n"
	       "		Retrieve range by time of an experiment(et), by relative time from trigger(tt),\n"
		   "		 by sampling number(ss). It can't be used with '-w' option.\n");
	printf("	[-f frame number ( 0=all, 'start:end'=ranged )\n"
	       "		Framed 2-D or other data retrieval.\n");
	printf("	[-h 'Transd server name' [-p 'base path'] [-n port_no] ]\n"
	       "		Direct connection mode without referring the Index database.\n");
	printf("	[-w | --wait [-t timeout (sec)] ]\n"
	       "		Data waiting, i.e. blocking, mode. Default timeout: 180.\n");
	printf("	[-V | -VF | -V4 | --volts ] | [-VV | -VD | -V8 | --double-volts ]\n"
	       "		Data are restored into voltage values in FLOAT or DOUBLE precision.)\n");
	printf("	[ --silent ]\n"
	       "		No working messages output.\n");
	printf("	[ --verbose ]\n"
	       "		Show detail information.\n");
	printf("	[-T | --timearray ]\n"
	       "		Make Files of Time Array and Time Parameter.\n");
	printf("	[-D | --double ]\n"
	       "		Make Time Array in double type (ignored if -T/--timearray option does not exist).\n");
	printf("	[-P | --param]\n");
	printf("		Only the parameter file is created.\n");
	printf("	[ --original-name ]\n"
	       "		Files are restored with the original names.\n");
	printf("	[ --signal-name ]\n"
	       "		Restored file names are converted to 'signal-name' from 'chno'.\n");
	printf("	[-R | --real ]\n"
	       "		Files are restored with real shot+subshot numbers, not alias ones.\n");
	return(-1);
}
const char* RANGE_NAME[] = {"","TimeOfExperiment","TimeFromTrigger","SamplingNumber","FrameNumber",""};

int main(int argc, char* argv[])
{
	if(argc < 5 || argc > 21) {
		return Usage( argv[0] );
	}
	int exit_status = 0;
	char*			Diag_Name		= argv[1];
	unsigned int	AShot_Number	= atoi(argv[2]);
	unsigned short	ASub_Shot_Number= atoi(argv[3]);
	char*			Channel			= argv[4];
	unsigned int	arc_shot;
	unsigned short	arc_sub;
	const char*		func_name;
	const char*		error_mes;

	char*	IndexServer	= getenv("INDEXSERVERNAME");
	char	Filename[256];
	char	Path[256]	={'\0'};
	char	Server[64]	={'\0'};
	int		PortNumber	=0;
	int		TimeoutSec	=180;
	bool	SwVerbose		= false;
	bool	bSilent			= false;
	bool	SwDirectAccess	= false;
	bool	SwWait			= false;
	bool	SwArcRealShot	= false;
	bool	SwVoltsFlt		= false;
	bool	SwVoltsDbl		= false;
	bool	SwOriginalName	= false;		// add 13.2.1
	bool	SwMakeTimeArray = false;		// add 14.1.1
	bool	SwDoubleTimeArray = false;		// add 14.1.1
	bool	SwSignalName	= false;		// add 16.0.0
	char*	path_for_orgname= NULL;			// add 13.2.1
	char	orgname[256];					// add 13.2.1
	char	suffixname[32];					// add 16.0.2
	char*	parg;
	int		ret = 0;
	int		chno;
	char* 		signal_name= NULL;
	bool	SwParamOnly	= false;		// add 18.1.0

	const char* fmt_frame="%d";
	bool range_err = false;
	int	range_type = 0;
	const char*	range_str="";
	
	strcpy(Filename, Diag_Name);
	for(int i=5; i < argc; i++)
	{
		parg = argv[i];
		if(*parg=='-')
		{
			bool	swChkOpt1Len = true;
			switch(*(parg+1))
			{
				case 'f':
					if( 0 != range_type ) range_err = true;
					range_type = 4;
					i++;
					if( i < argc ) range_str=argv[i];
					break;
				case 'h':
					i++;
					SwDirectAccess = true;
					if( i < argc ) strcpy(Server, argv[i]);
					break;
				case 'p':
					i++;
					if( i < argc ) strcpy(Path, argv[i]);
					break;
				case 'n':
					i++;
					if( i < argc ) PortNumber=atoi(argv[i]);
					break;
				case 't':
					i++;
					if( i < argc ) TimeoutSec=atoi(argv[i]);
					break;
				case 'T':
					SwMakeTimeArray = true;
					break;
				case 'D':
					SwDoubleTimeArray = true;
					break;
				case 'w': // 2009-07-29
					SwWait = true;
					break;
				case 'R': // 2009-09-14
					SwArcRealShot = true;
					break;
				case 'P':
					SwParamOnly = true;
					break;
				case '-': // 2009-09-14
					swChkOpt1Len = false;
					if( 0 == strcmp(parg+1,"-wait") ) {
						SwWait = true;
					}
					else if( 0 == strcmp(parg+1,"-real") ) {
						SwArcRealShot = true;
					}
					else if( 0 == strcmp(parg+1,"-volts") ) {
						SwVoltsFlt = true;
						break;
					}
					else if( 0 == strcmp(parg+1,"-double-volts") ) {
						SwVoltsDbl = true;
						break;
					}
					else if( 0 == strcmp(parg+1,"-silent") ) {
						SwVerbose = false;
						bSilent	= true;
						break;
					}
					else if( 0 == strcmp(parg+1,"-verbose") ) {
						SwVerbose = true;
						break;
					}
					else if( 0 == strcmp(parg+1,"-original-name") ) {
						SwOriginalName = true;
						break;
					} else if( 0 == strcmp(parg+1,"-timearray") ) {
						SwMakeTimeArray = true;
						break;
					} else if( 0 == strcmp(parg+1,"-double") ) {
						SwDoubleTimeArray = true;
						break;
					} else if( 0 == strcmp(parg+1,"-param") ) {
						SwParamOnly = true;
						break;
					} else if( 0 == strcmp(parg+1,"-signal-name") ) {
						SwSignalName = true;
						break;
					} else if( 0 == strncmp(parg+1,"-format-frame=", strlen("-format-frame=")) ) {
						char* cwk=parg+1+strlen("-format-frame=");
						if( *cwk == '%' ) {
							fmt_frame=cwk;
						}
						break;
					} else if( 0 == strcmp(parg+1,"-et") ) {
						if( 0 != range_type ) range_err = true;
						range_type = 1;
						i++;
						if( i < argc ) range_str=argv[i];
						break;
					} else if( 0 == strcmp(parg+1,"-tt") ) {
						if( 0 != range_type ) range_err = true;
						range_type = 2;
						i++;
						if( i < argc ) range_str=argv[i];
						break;
					} else if( 0 == strcmp(parg+1,"-ss") ) {
						if( 0 != range_type ) range_err = true;
						range_type = 3;
						i++;
						if( i < argc ) range_str=argv[i];
						break;
					}
					else {
						swChkOpt1Len = true;
					}
					break;
				case 'V': // 2010-03-10
					if( 3 > strlen(parg+1) ){
						swChkOpt1Len = false;
						switch(*(parg+2))
						{
							case '\0':
							case 'F':
							case '4':
								SwVoltsFlt = true;
								break;
							case 'V':
							case 'D':
							case '8':
								SwVoltsDbl = true;
								break;
							default:
								swChkOpt1Len = true;
								break;
						}
					}
					break;
				default:
					return Usage( argv[0] );
					break;
			}	// End of Switch
			if( (swChkOpt1Len && 1 != strlen(parg+1)) || (SwVoltsDbl && SwVoltsFlt) ||
				 range_err || (SwWait && (0!=range_type)) ) 
				return Usage( argv[0] );
		}
		else {
			size_t len = strlen(parg);
#if defined(WIN32) || defined(WIN64)
			if( parg[len-1] == '\\' ) {
#else
			if( parg[len-1] == '/' ) {
#endif
				path_for_orgname = new char[len+1];
				strcpy(path_for_orgname, parg);
				sprintf(Filename ,"%s%s", parg, Diag_Name);

			}
			else {
				strcpy(Filename, parg);
			}
		}
	}	// End of for(int argc

	int chs_cnt = 0;
	short* st_chs = NULL;
	short* en_chs = NULL;
	for(;;) {
		if( !SwDirectAccess ) retrieve_SetTestPort(PortNumber);

		if( !SwDirectAccess && NULL == IndexServer ) {
			exit_status = RTR_ER_UNDEFINE_INDEX_ENV;
			error_mes = "Environment variable INDEXSERVERNAME unknown!";
			break;
		}
		chs_cnt = ChannelDecode(Channel, NULL, NULL);
		if( 0 > chs_cnt ) {
			exit_status = RTR_ILLEGAL_CH_NUMBER;
			error_mes = "Illegal channel number!";
			break;
		}
		else if( 0 == chs_cnt ) {
			chs_cnt = 1;
			st_chs = new short[chs_cnt];
 			en_chs = new short[chs_cnt];
			signal_name = Channel;
			st_chs[0] = 1;
			en_chs[0] = 1;
		}
		else {
			st_chs = new short[chs_cnt];
 			en_chs = new short[chs_cnt];
      		chs_cnt = ChannelDecode(Channel, st_chs, en_chs);
		}
		
		if( SwOriginalName && ( SwVoltsDbl || SwVoltsFlt ) ) {
			exit_status = RTR_INVALID_V_OPTION;
			error_mes = "Cannot use optional -V group and --original_name at the same time.";
		}
		break;
	}
	
	if( 0 != exit_status ) {
		if( DISP )	printf("<Error: %s>\n" ,error_mes);
		return exit_status;
	}

	retrieveResetIndexServerName();

	if( SwOriginalName && NULL == path_for_orgname ) {
		path_for_orgname = new char[1];
		path_for_orgname[0] = '\0';
	}

	startIndexNoClosing();
	int rd = -1;
	if( !SwWait ) TimeoutSec = 0;
	if ( SwDirectAccess) {
		if( '\0' == Path[0] ) strcpy(Path,"ShotDataFS");
		func_name = "retrieveOpenDirectWait";
		rd=retrieveOpenDirectWait(Diag_Name, Server, Path, AShot_Number, ASub_Shot_Number, PortNumber,TimeoutSec);
	}
	else {
		func_name = "retrieveOpenWaitWithRange";
//		rd=retrieveOpenWait(Diag_Name,IndexServer,AShot_Number,ASub_Shot_Number,TimeoutSec);
		rd=retrieveOpenWaitWithRange(Diag_Name,IndexServer,AShot_Number,ASub_Shot_Number,TimeoutSec,range_type,range_str);
	}
	if(0 > rd ) {
		if( DISP )	printf("Error %d [ %s ] from DLL(%s)!\n" , rd ,retrieveErrorMessage(rd),func_name);
		endIndexNoClosing();
		return rd;
	}

	char fmt_frame_filename_s[32];
	char fmt_frame_filename_c[32];
	sprintf(fmt_frame_filename_s,"%s-%s-%s.%s", "%s", "%s", fmt_frame, "%s");	// signal
	sprintf(fmt_frame_filename_c,"%s-%s-%s.%s", "%s", "%d", fmt_frame, "%s");	// ch_no

	unsigned int n_channel;
	short	year ,month ,day ,hour ,min ,sec;
	char	management[32];
	char	comment[128];
	int		comment_size=128;
	char	cserver[32];

	for(ret=0;;) {
		func_name = "retrieveShotInfo";
		ret=retrieveShotInfo( rd ,&n_channel ,&year ,&month ,&day ,&hour ,&min ,&sec ,
								   management ,comment ,comment_size ,cserver ); 
		if(0 > ret ) break;
		int real_channel = n_channel;
		if( SwDirectAccess && 0 == n_channel )	n_channel = 9999;

		if( SwArcRealShot ) {
			func_name = "retrieveRealShotNumber";
			ret=retrieveRealShotNumber( rd, &arc_shot, &arc_sub );
			if( 0 != ret ) break;
		}
		else {
			arc_shot= AShot_Number;
			arc_sub	= ASub_Shot_Number;
		}

		if( SwVerbose ) {
			printf("---Arc Shot Infomation---\n");
			printf("Index Server Name  = %s\n",IndexServer);
			printf("Trans Server Name  = %s\n",cserver);
			printf("Shot Number        = %10u\n",arc_shot);
			printf("Sub Shot Number    = %10hu\n",arc_sub);
			printf("Number Of Channel  = %10u\n",real_channel);
			printf("Channel            = %s\n", Channel);
	//		printf("Channel            = %3d:%3d\n",sch,ech);
			printf("DATE               = %4d-%2d-%2d\n",year,month,day);
			printf("TIME               = %4d:%2d:%2d\n",hour,min,sec);
		}
		break;
	}
	if(0 > ret ) {
		if( DISP )	printf("Error %d [ %s ] from DLL(%s)!\n" , ret, retrieveErrorMessage(ret), func_name);
		retrieveClose( rd );
		endIndexNoClosing();
		return ret;
	}

	for(int i=0;i<chs_cnt;i++) {
		if( 0 == en_chs[i] )	en_chs[i] = n_channel;
		if( 0 == st_chs[i] )	st_chs[i] = 1;
		if( n_channel < (unsigned int)st_chs[i] || n_channel < (unsigned int)en_chs[i]) {
			if( DISP ) printf("<Error: Illegal start or end channel number!>\n");
			retrieveClose( rd );
			endIndexNoClosing();
			return RTR_ILLEGAL_CH_NUMBER;
		}
	}
	{
		char tmpwork[256];
		strcpy(tmpwork, Filename);
		sprintf(Filename, "%s-%u-%hu", tmpwork, arc_shot, arc_sub);
	}
	int64_t data_length;
	int64_t comp_length;
	unsigned short param_count;
	short data_type;
	char image_type[32];
	unsigned short value_len;
	int is_nframe;
	const char *data_type_name;

	const char* FMT_ERDLCH_dssd		= "Error %d [ %s ] from DLL(%s CH=%d)!\n";
	const char* FMT_ERDLSN_dsss		= "Error %d [ %s ] from DLL(%s SignalName=%s)!\n";
	const char* FMT_EROPEN_d_s		= "Error %d\n Can't open the file[%s]\n";
	const char* FMT_ERDLCH_ndssd	= "Error %d\n [ %s ] from DLL(%s CH=%d)!\n";
	const char* FMT_ERDLFR_dssdd	= "Error %d [ %s ] from DLL(%s CH=%d FRAME=%d)!\n";
	const char* FMT_ERDLFR_ndssdd	= "Error %d\n [ %s ] from DLL(%s CH=%d FRAME=%d)!\n";
	exit_status = 0;
	for(int loop=0; loop<chs_cnt; loop++ ) {
		int st_ch = st_chs[loop];
		int en_ch = en_chs[loop];
		int inc =1;
		chno=st_ch;
		if( st_ch > en_ch ) {
			inc = -1;
			st_ch = en_ch;
			en_ch = chno;
		}
		char *filepath	= new char[256];
		int64_t ret_length;
		for(int cloop=st_ch ;cloop<=en_ch ;cloop++,chno += inc)	{
			if( NULL == signal_name ) {
				ret=retrieveChInfo_ex( rd ,chno ,
						&data_length ,&comp_length ,&param_count ,&data_type ,image_type ,&value_len ,&is_nframe ,
						management ,comment ,comment_size );
				if( -20003 == ret && 9999 == n_channel ) break;
				if(0 > ret) {
					if( DISP )	printf( FMT_ERDLCH_dssd, ret, retrieveErrorMessage(ret), "retrieveChInfo_ex", chno);
					exit_status = ret;
					continue;
				}
			}
			else {
				ret=retrieveChInfo2_ex( rd ,signal_name ,
						&data_length ,&comp_length ,&param_count ,&data_type ,image_type ,&value_len ,&is_nframe ,
						management ,comment ,comment_size, &chno );
				if(0 > ret) {
					if( DISP )	printf( FMT_ERDLSN_dsss, ret, retrieveErrorMessage(ret), "retrieveChInfo2_ex", signal_name);
					exit_status = ret;
					continue;
				}
			}

			
			switch(data_type)
			{
				case RAW_DATA:
					data_type_name="RAW";
					break;
				case ANA_DATA:
					data_type_name="ANA";
					break;
				default:
					data_type_name="???";
					break;
			}
			int64_t volts_buf_size	= 0;
			if( SwVoltsDbl || SwVoltsFlt ) {
				if(       9 > value_len ) {	volts_buf_size = data_length;	}
				else if( 17 > value_len ) {	volts_buf_size = data_length/2;	}
				else if( 33 > value_len ) {	volts_buf_size = data_length/4;	}
				else if( 65 > value_len ) {	volts_buf_size = data_length/8;	}	// 2015-06-05
				int syn_num =retrieveChVsynthesizedNumber( rd, chno );
				if( syn_num != 0 )	{	volts_buf_size /= syn_num; }
				else				{	volts_buf_size = 0;	}
			}
			if( SwVerbose ) {
				printf("---Channel Information---\n");
				printf("Channel Number     = %d\n"	,chno);
				printf("Data Type          = %s\n"	,data_type_name);
				printf("Data Size          = %lld\n"	,data_length);
				printf("Comp Size          = %lld\n"	,comp_length);
				if( 0 != is_nframe )
					printf("Number of Frame    = %d\n"	,is_nframe);
				printf("Comment            = %s\n"	,comment);
			}
			
			orgname[0]='\0';
			suffixname[0]='\0';
			ret = 0;
			int	j = 0;
			char**	Key = NULL;
			char**	Val = NULL;
			int*	Typ = NULL;
			const char*	module_type = "unkown";
			if( 0 < param_count ) {
				Key=new char *[param_count];
				Val=new char *[param_count];
				Typ=new int[param_count];
				for(j=0;j<param_count;j++)	{
					Key[j]=new char[128];
					Val[j]=new char[128];
				}
				for(;;) {
					ret=retrieveChParams(rd, chno, Key ,Val , Typ );
					if( 0 > ret ) {
						if( DISP )	printf( FMT_ERDLCH_dssd, ret, retrieveErrorMessage(ret), "retrieveChParams", chno);
						break;
					}
					ret = 0;
					for(j=0;j<param_count;j++) {
						if( 0 == strcmp("ModuleType",Key[j]) ) {
							module_type = Val[j];
							break;
						}
					}
					if( SwOriginalName ) {
						for(j=0;j<param_count;j++) {
							if( 0 == strcmp("FileName",Key[j]) ) {
								strcpy(orgname,Val[j]);
							}
							else if( 0 == strcmp("FileSuffix",Key[j]) ) {
								strcpy(suffixname,Val[j]);
							}
						}
					}
					break;
				}
			}
			FILE *fp		= NULL;
			if( '\0' == suffixname[0] ) {
				strcpy(suffixname, "dat");
			}
			filepath[0] = '\0';
			if( SwOriginalName ) {
				if( '\0' != orgname[0] ) {
					sprintf(filepath,"%s%s.prm",path_for_orgname,orgname);
				}
				else {
					if( DISP ) printf("<Warning: undefined original file name.>\n");
				}
			}
			if( '\0' == filepath[0] ) {
				if( NULL != signal_name && SwSignalName ) {
					sprintf(filepath,"%s-%s.prm", Filename, signal_name);
				}
				else {
					sprintf(filepath,"%s-%d.prm", Filename, chno);
				}
			}
			if( DISP ) printf("-----Save to parameter file      [%s ]...",filepath);
			if((fp=fopen(filepath,"w"))==NULL)
			{
				if( DISP ) printf(FMT_EROPEN_d_s, errno, filepath);
				retrieveClose( rd );
				exit_status = RTR_ERROR_FILE_OPEN;
				break;		// -- exit for loop ch.
			}

			for(j=0;j<param_count;j++) {
				if( 1 == (int)Typ[j] && retrieve_check_string(Val[j]) ) {
					fprintf(fp,"%s,%s,\"%s\",%d\n" ,module_type ,Key[j] ,Val[j] ,(int)Typ[j]);
				}
				else {
					fprintf(fp,"%s,%s,%s,%d\n" ,module_type ,Key[j] ,Val[j] ,(int)Typ[j]);
				}
			}

			if( 0 != range_type ) {
				fprintf(fp,"%s,RetrieveRange,%s,1\n" ,module_type ,RANGE_NAME[range_type]) ;
				fprintf(fp,"%s,RetrieveRangeValue,%s,1\n" ,module_type ,range_str) ;
			}
			fclose(fp);
			if( -1 < ret ) {
				if( DISP ) printf("OK\n");
			}
			else {
				exit_status = ret;
			}

			if( SwMakeTimeArray ) {
				char		DTSsource[64], DTShostID[64], DTSmoduleID[64], CLKsource[64], CLKhostID[64], CLKmoduleID[64];
				char		DTStriggerChannel[64], DTSclockChannel[64], ExtOrInt[64];
				int			DTSuserDefine;
				int64_t		timeArraySize;
				int64_t		time_data_length;

				void* timeArray=NULL;
				void* tmp_clock=NULL;
				void* tmp_start=NULL;
				void* tmp_delay=NULL;

				int bytes_per_data;
				if(SwDoubleTimeArray) {
					tmp_clock = new double;
					tmp_start = new double;
					tmp_delay = new double;
					bytes_per_data = sizeof(double);
				}
				else {
					tmp_clock = new float;
					tmp_start = new float;
					tmp_delay = new float;
					bytes_per_data = sizeof(float);
				}
				ret=retrieveTimeInfo( rd, chno,
										DTSsource, DTShostID, DTSmoduleID, DTStriggerChannel,  
										CLKsource, CLKhostID, CLKmoduleID, DTSclockChannel,
										&DTSuserDefine, ExtOrInt, &timeArraySize,
										tmp_clock, tmp_delay, tmp_start, SwDoubleTimeArray);

				if(0 == ret && timeArraySize > 0) {
					if( !SwParamOnly ) {
						if(SwDoubleTimeArray)	timeArray = new double[timeArraySize];
						else					timeArray = new float[timeArraySize];
					}
					ret=retrieveTimeData( rd, chno, timeArray, timeArraySize, &time_data_length, SwDoubleTimeArray);
					if(ret) {
						if( DISP )	printf(FMT_ERDLCH_dssd, ret, retrieveErrorMessage(ret), "retrieveTimeData", chno);
					}
				}

				for( ;; ) {
					if( 0 != ret ) break;	// --exit for loop

					if( !SwParamOnly ) {
						if( NULL != signal_name && SwSignalName ) {
							sprintf(filepath,"%s-%s.time", Filename, signal_name);
						}
						else {
							sprintf(filepath,"%s-%d.time", Filename, chno);
						}

						if( DISP )		printf("-----Save to time data file      [%s]...", filepath);
						if((fp=fopen(filepath,"wb")) == NULL) {
							if( DISP )	printf(FMT_EROPEN_d_s, errno, filepath);
							ret = RTR_ERROR_FILE_OPEN;
							break;	// --exit for loop ch
						}

						subdivided_fwrite(timeArray, bytes_per_data, timeArraySize, fp);
						fclose(fp);

						if( DISP )		printf("OK\n");
					}
					if( NULL != signal_name && SwSignalName ) {
						sprintf(filepath,"%s-%s.tprm", Filename, signal_name);
					}
					else {
						sprintf(filepath,"%s-%d.tprm", Filename, chno);
					}

					if( DISP )		printf("-----Save to time parameter file [%s]...", filepath);
					if((fp=fopen(filepath,"w"))==NULL)	{
						if( DISP )	printf(FMT_EROPEN_d_s, errno, filepath);
						ret = RTR_ERROR_FILE_OPEN;
						break;	// --exit for loop ch
					}

					fprintf(fp,"DTSsource,%s\n", DTSsource);
					fprintf(fp,"DTShostID,%s\n", DTShostID);
					fprintf(fp,"DTSmoduleID,%s\n", DTSmoduleID);
					fprintf(fp,"TriggerCh,%s\n", DTStriggerChannel);
					if( arc_shot >= 56221) {
						fprintf(fp,"CLKsource,%s\n", CLKsource);
						fprintf(fp,"CLKhostID,%s\n", CLKhostID);
						fprintf(fp,"CLKmoduleID,%s\n", CLKmoduleID);
					} 
					fprintf(fp,"ClockCh,%s\n", DTSclockChannel);
					fprintf(fp,"ClockSource,%s\n", ExtOrInt);
#if defined(WIN32) || defined(WIN64)
					fprintf(fp,"TimeArraySize,%I64d\n", timeArraySize);
#else
					fprintf(fp,"TimeArraySize,%lld\n", timeArraySize);
#endif
					const char* time_fmt = "%s,%2.8fsec\n";
					if(SwDoubleTimeArray){
						double cycle = *(double*)tmp_clock;
						if( 0.000000001 > cycle ) {
							time_fmt = "%s,%2.15fsec\n";
						}
						else if( 0.000001 > cycle ) {
							time_fmt = "%s,%2.12fsec\n";
						}
						fprintf(fp,"ArrayDataType,double\n");
						fprintf(fp, time_fmt, "ClockCycle",		cycle );
						fprintf(fp, time_fmt, "StartTiming",	*(double*)tmp_start);
					}else{
						float cycle = *(float*)tmp_clock;
						if( (float)0.000000001 > cycle ) {
							time_fmt = "%s,%2.15fsec\n";
						}
						else if( (float)0.000001 > cycle ) {
							time_fmt = "%s,%2.12fsec\n";
						}
						fprintf(fp,"ArrayDataType,float\n");
						fprintf(fp, time_fmt, "ClockCycle",		cycle );
						fprintf(fp, time_fmt, "StartTiming",	*(float*)tmp_start);
					}

					fclose(fp);
					if( DISP )		printf("OK\n");
					break;	// --exit for loop write time data
				}	// --end for loop write time data
				if(SwDoubleTimeArray) {
					delete (double*)tmp_clock;
					delete (double*)tmp_start;
					delete (double*)tmp_delay;
					if(timeArray) delete[] (double*)timeArray;
				}
				else {
					delete (float*)tmp_clock;
					delete (float*)tmp_start;
					delete (float*)tmp_delay;
					if(timeArray) delete[] (float*)timeArray;
				}

			}	// -- end if SwMakeTimeArray
			for(j=0;j<param_count;j++) {
				delete[] Key[j];
				delete[] Val[j];
			}
			if( NULL != Typ )	delete[] Typ;
			if( NULL != Val )	delete[] Val;
			if( NULL != Key )	delete[] Key;

			if( 0 != ret ) {
				exit_status = ret;
				break;	// -- exit for loop ch.
			}
			if( SwParamOnly ) continue;

			if( 0 == is_nframe ) {
				filepath[0] = '\0';
				if( SwOriginalName ) {
					if( '\0' != orgname[0] ) {
						sprintf(filepath,"%s%s",path_for_orgname,orgname);
					}
					else {
						if( DISP ) printf("<Warning: undefined original file name.>\n");
					}
				}
				if( '\0' == filepath[0] ) {
					if( NULL != signal_name && SwSignalName ) {
						sprintf(filepath,"%s-%s.%s", Filename, signal_name, suffixname);
					}
					else {
						sprintf(filepath,"%s-%d.%s", Filename, chno, suffixname);
					}
				}
				if( DISP ) printf("-----Save to data file           [%s ]...", filepath);
				if((fp=fopen(filepath,"wb"))==NULL)		{
					if( DISP ) printf(FMT_EROPEN_d_s, errno, filepath);
					retrieveClose( rd );
					exit_status = RTR_ERROR_FILE_OPEN;
					break;	// -- exit for loop ch
				}
				ret = 0;
				if(0 < data_length)		{
					for(;;) {
						if( SwVoltsDbl ) {
							if( 0 == volts_buf_size ) {
								if( DISP ) 
									printf("Error\n No-supported resoution(bit=%d) (CH=%d)!\n" ,value_len,chno);
								ret = RTR_NO_SUPPORTED_RESOUTION;
								break;	// --exit for loop write-data
							}
							double* buf=new double[volts_buf_size];
							ret=retrieveChVoltsDbl_ex(rd, chno, buf, volts_buf_size, &ret_length);
							if(0 > ret) {
								if( DISP )	printf(FMT_ERDLCH_ndssd , ret, retrieveErrorMessage(ret), "retrieveChVoltsDbl_ex", chno);
							}
							else {
								subdivided_fwrite(buf,sizeof(double),ret_length,fp);
							}
							delete[] buf;
						}
						else if( SwVoltsFlt ) {
							if( 0 == volts_buf_size ) {
								if( DISP ) 
									printf("Error\n No-supported resoution(bit=%d) (CH=%d)!\n",value_len,chno);
								ret = RTR_NO_SUPPORTED_RESOUTION;
								break;	// --exit for loop write-data
							}
							float* buf=new float[volts_buf_size];
							ret=retrieveChVolts_ex(rd, chno, buf, volts_buf_size, &ret_length);
							if(0 > ret) {
								if( DISP )	printf(FMT_ERDLCH_ndssd, ret, retrieveErrorMessage(ret), "retrieveChVolts_ex", chno);
							}
							else {
								subdivided_fwrite(buf,sizeof(float),ret_length,fp);
							}
							delete[] buf;
						}
						else {
							char* data=new char[data_length];
							ret=retrieveChData_ex(rd, chno, data, data_length, &ret_length);
							if(0 > ret) {
								if( DISP )	printf(FMT_ERDLCH_ndssd , ret, retrieveErrorMessage(ret), "retrieveChData_ex", chno);
							}
							else {
								subdivided_fwrite(data, 1, ret_length, fp);
							}
							delete[] data;
						}
						break;	// --exit for loop write-data
					}	// --end for loop write-data
				}	// --end if
				fclose(fp);
				if( 0 == ret ) {
					if( DISP ) printf("OK\n");
				}
				else {
					exit_status = ret;
				}
			}
			else {
				int64_t start_no = 1, end_no = is_nframe;
				ret=retrieveGetRetrieveNo( rd, chno , &start_no, &end_no);
				if(-2 != ret && 0 > ret) {
					if( DISP ) printf(FMT_ERDLCH_dssd, ret, retrieveErrorMessage(ret), "retrieveGetRetrieveNo", chno);
					continue;
				}

				int64_t	data_length;
				int	frame_x;
				int	frame_y;
				ret=retrieveFrameInfo_ex( rd, chno, (int)start_no, &data_length, image_type, &frame_x, &frame_y ); 
				if(0 > ret) {
					if( DISP ) printf( FMT_ERDLFR_dssdd, ret, retrieveErrorMessage(ret), "retrieveFrameInfo_ex", chno, (int)start_no);
					exit_status = ret;
					continue;
				}

				int64_t	ret_length;
				char*			frame_data = NULL;
				for(int frno=start_no; frno<=end_no ; frno++ ) {
					if( NULL != signal_name && SwSignalName ) {
						sprintf(filepath, fmt_frame_filename_s, Filename, signal_name, frno, suffixname);
					}
					else {		
						sprintf(filepath, fmt_frame_filename_c, Filename, chno, frno, suffixname);
					}
					if( DISP ) printf("-----Save to data file           [%s ]...", filepath);
					if((fp=fopen(filepath,"wb"))==NULL)		{
						if( DISP ) printf(FMT_EROPEN_d_s, errno, filepath);
						exit_status = RTR_ERROR_FILE_OPEN;
						break;	// --exit loop frame
					}
					ret = 0;
					if(0 < data_length)		{
						frame_data=new char[data_length];
						ret=retrieveFrameData_ex(rd,chno, frno, frame_data, data_length, &ret_length);
						if(0 > ret) {
							if( DISP ) printf(FMT_ERDLFR_ndssdd, ret, retrieveErrorMessage(ret), "retrieveFrameData_ex", chno, frno);
						}
						else {
								subdivided_fwrite(frame_data,1,ret_length,fp);
						}
						delete[] frame_data;
					}	
					fclose(fp);
					if( -1 < ret ) {
						if( DISP ) printf("OK\n");
					}
					else {
						exit_status = ret;
					}
					if( 0 != exit_status ) break;	// --exit loop frame
				}	// -- end for loop frame
			}	// -- end if 
			if( 0 != exit_status ) break;	// --exit loop ch

		}	// -- end for loop cloop
		delete[] filepath;
		if( 0 != exit_status ) break;	// --exit loop chs_cnt
	}	// -- end for loop chs_cnt

	if( 0 < rd ) retrieveClose( rd );
	endIndexNoClosing();
	return exit_status;
}
